package BuiltIns;

import java.awt.*;
import Type.*;
import Main.*;
import java.awt.geom.Arc2D;

public class ArcFigure extends Figure {
	
	IntType radius, lineWidth;
	FloatType start, end;
	BoolType fill, clockwise;

	/* Constructor */
	public ArcFigure(AbstractType... args) {
		if (args[0] != null) {
			loc = (PairType) args[0];
		}

		if (args[1] != null) {
			radius = (IntType) args[1];
		}
		else throw new Error("Radius must be specified.");

		if (args[2] != null) {
			start = (FloatType) args[2];
		}
		else start = new FloatType(0);

		if (args[3] != null) {
			end = (FloatType) args[3];
		}
		else end = new FloatType(2*Math.PI);

		if (args[4] != null) {
			color = (ColorType) args[4];
		}
		
		if (args[5] != null) {
			fill = (BoolType) args[5];
		}
		else fill = new BoolType(true);
		
		if (args[6] != null) {
			lineWidth = (IntType) args[6];
		}
		else lineWidth = new IntType(1);

		if (args[7] != null) {
			clockwise = (BoolType) args[7];
		}
		else clockwise = new BoolType(true);
	}

	public void draw(Graphics g) {
		Graphics2D g2 = (Graphics2D) g;
		g2.setStroke(new BasicStroke(lineWidth.value));
		g2.setColor(color.getColor());
		Arc2D.Float a = new Arc2D.Float();
		if (clockwise.value) {
			a = new Arc2D.Float(loc.x.value, loc.y.value, radius.value, radius.value, (float) (180/Math.PI)*end.value, (float) (180/Math.PI)*(end.value - start.value), Arc2D.OPEN);
		}
		else {
			a = new Arc2D.Float(loc.x.value, loc.y.value, radius.value, radius.value, (float) (180/Math.PI)*start.value, (float) (180/Math.PI)*(end.value - start.value), Arc2D.OPEN);
		}
		if (_visible) {
			g2.draw(a);
			if (fill.value) {
				g2.fill(a);
			}
		}
	}
}
