package BuiltIns;

import java.awt.*;
import java.awt.geom.Path2D;
import Type.*;
import Main.*;

public class PolyFigure extends Figure {
	
	ListType points;
	IntType lineWidth;
	BoolType fill;

	/* Constructor */
	public PolyFigure(AbstractType... args) {
		if (args[0] != null) {
			loc = (PairType) args[0];
		}

		if (args[1] != null) {
			points = (ListType) args[1];
		}
		else throw new Error("Points must be specified.");

		if (args[2] != null) {
			color = (ColorType) args[2];
		}
		
		if (args[3] != null) {
			fill = (BoolType) args[3];
		}
		else fill = new BoolType(true);
		
		if (args[4] != null) {
			lineWidth = (IntType) args[4];
		}
		else lineWidth = new IntType(1);
	}

	public void draw(Graphics g) {
		Graphics2D g2 = (Graphics2D) g;
		g2.setStroke(new BasicStroke(lineWidth.value));
		g2.setColor(color.getColor());

		Path2D.Float poly = new Path2D.Float();
		boolean isFirst = true;
		for (int i = 0; i < points.size(); ++i) {
			PairType v = (PairType) points.get(i);
			if (isFirst) {
				poly.moveTo(v.x.value + loc.x.value, v.y.value + loc.y.value);
				isFirst = false;
			}
			else {
				poly.lineTo(v.x.value + loc.x.value, v.y.value + loc.y.value);
			}
		}
		poly.closePath();

		g2.draw(poly);
		if (fill.value) {
			g2.fill(poly);
		}
	}
}
