package BuiltIns;

import java.awt.*;
import java.awt.geom.Rectangle2D;
import Type.*;
import Main.*;

public class RectFigure extends Figure {
	
	IntType width, height, lineWidth;
	BoolType fill;

/* Constructor */
	public RectFigure(AbstractType... args) {
		if (args[0] != null) {
			loc = (PairType) args[0];
		}

		if (args[1] != null) {
			width = (IntType) args[1];
		}
		else throw new Error("Width must be specified.");

		if (args[2] != null) {
			height = (IntType) args[2];
		}
		else throw new Error("Height must be specified.");

		if (args[3] != null) {
			color = (ColorType) args[3];
		}
		
		if (args[4] != null) {
			fill = (BoolType) args[4];
		}
		else fill = new BoolType(true);
		
		if (args[5] != null) {
			lineWidth = (IntType) args[5];
		}
		else lineWidth = new IntType(1);
	}

/* Draw a rectangle by getting the values of all the parameters */
	public void draw(Graphics g) {
		Graphics2D g2 = (Graphics2D) g;
		g2.setStroke(new BasicStroke(lineWidth.value));
		g2.setColor(color.getColor());
		Rectangle2D.Float r = new Rectangle2D.Float(loc.x.value, loc.y.value, width.value, height.value);
		if (_visible) {
			g2.draw(r);
			if (fill.value) {
				g2.fill(r);
			}
		}
	}
}
