package BuiltIns;

import java.awt.*;
import java.awt.Font;
import Type.*;
import Main.*;

public class TextFigure extends Figure {
	
	StringType text, font;
	IntType size;

/* Constructor */
	public TextFigure(AbstractType... args) {
		if (args[0] != null) {
			loc = (PairType) args[0];
		}

		if (args[1] != null) {
			text = (StringType) args[1];
		}
		else throw new Error("Text must be specified.");

		if (args[2] != null) {
			color = (ColorType) args[2];
		}
		
		if (args[3] != null) {
			size = (IntType) args[3];
		}
		else size = new IntType(12);

		if (args[4] != null) {
			font = (StringType) args[4];
		}
		else font = new StringType("Arial");
	}

/* Go from the font name and size to a physical font available on the machine */
	private Font getFont() {
		GraphicsEnvironment ge = GraphicsEnvironment.getLocalGraphicsEnvironment();
		String fontFamilies[] = ge.getAvailableFontFamilyNames();
		if (java.util.Arrays.asList(fontFamilies).contains(font.value)) {
			return new Font(font.value, Font.PLAIN, size.value);
		}
		else throw new Error("The given font is not available on this machine.");
	}

	public void draw(Graphics g) {
		Graphics2D g2 = (Graphics2D) g;
		g2.setRenderingHint(RenderingHints.KEY_ANTIALIASING, RenderingHints.VALUE_ANTIALIAS_ON);
		g2.setColor(color.getColor());
		g2.setFont(this.getFont());
		g2.drawString(text.value, loc.x.value, loc.y.value);;
	}
}
